﻿namespace UltraGridCheckBoxColumnWithText
{
    using System;
    using System.Data;
    using System.Diagnostics;
    using System.Windows.Forms;

    using Infragistics.Win.UltraWinEditors;
    using Infragistics.Win.UltraWinGrid;

    public partial class Form1 : Form
    {
        private const int Rows = 10;

        public Form1()
        {
            this.InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.ultraGrid1.DataSource = this.GetData(Rows);
            UltraCheckEditor checkBox = new UltraCheckEditor();
            checkBox.Text = "This is custom text";
            this.ultraGrid1.DisplayLayout.Bands[0].Columns[1].EditorComponent = checkBox;
        }

        private void UltraGrid1_CellChange(object sender, CellEventArgs e)
        {
            UltraGridCell cell = e.Cell;
            if (cell == null)
            {
                return;
            }

            if (cell.Column.Header.Caption == "Check Box With Text")
            {
                Debug.WriteLine(string.Format("Checkbox state changed to {0}", bool.Parse(cell.Text)));
            }
        }

        private DataTable GetData(int rows)
        {
            DataTable dt = new DataTable();

            dt.Columns.Add("Id", typeof(int));
            dt.Columns.Add("Check Box With Text", typeof(bool));

            for (int row = 0; row < rows; row++)
            {
                int id = row + 1;
                bool checkState = row % 3 == 0;
                string text = "Row #" + (row + 1);

                dt.Rows.Add(new object[] { id, checkState });
            }

            return dt;
        }
    }
}
